#!/usr/bin/python
#########################################################
# pyDict - A pygtk2 dictionary                          #
#                                                       #
# this is a program that utilize the library of xdict.  #
# Made by Daniel Gau <plateau@wahoo.com.tw>             #
#-------------------------------------------------------#
# Ported and rewritten by Leon Ho <llch@redhat.com>     #
#-------------------------------------------------------#
#########################################################

import gtk
import gobject
import string
import sys, os
import dictBackend

import gettext
gettext.bindtextdomain("pydict", "/usr/share/locale")
gettext.textdomain("pydict")
_=gettext.gettext

class mainWindow:
    def destroy(self, *args):
        gtk.main_quit()

    def on_menu_about(self, *args):
        adialog = gtk.Dialog("About pydict2", self.mainWindow, gtk.DIALOG_MODAL, (gtk.STOCK_OK, gtk.RESPONSE_OK))
        hbox = gtk.HBox(False, 8)
        hbox.set_border_width(8)
        adialog.vbox.pack_start(hbox)

        image = gtk.Image()
        image.set_from_file('/usr/share/pydict/yaba.xpm')
        hbox.pack_start(image)

        label = gtk.Label("Made by Daniel Gau\n<plateau@pagic.net>\nfor my lovely wife, Cecile Ho.\n\n\n\n\n\npydict2 rewritten by Leon Ho\n<llch@redhat.com>")
        hbox.pack_start(label)
        adialog.show_all()
        adialog.run()
        adialog.destroy()

    def on_menu_help(self,*args):
        hwin = helpWindow(file = "/usr/X11R6/lib/X11/pyDict/HELP")
        hwin.show()

    def __init__(self):
        self.mainWindow = gtk.Window()

        self.mainWindow.set_title("pyDict2 v0.50")
        self.mainWindow.connect("delete-event", self.destroy)
        self.toplevelVBox = gtk.VBox()

        # -- Menu Bar --
        self.menuBar = gtk.MenuBar()

        accel_group = gtk.AccelGroup()
        item_fac = gtk.ItemFactory(gtk.MenuBar, "<main>", accel_group)

        self.mainWindow.add_accel_group(accel_group)
        item_fac.create_items([
            ('/_File',                   None,    None, 0, '<Branch>'),
            ('/_File/E_xit',             None,    self.destroy, 6, ''),
            ('/_Help',                   None,    None, 0, '<Branch>'),
            ('/_Help/_Help...',            None,    self.on_menu_help, 2, ''),
            ('/_Help/_About...',            None,    self.on_menu_about, 2, ''),
            ])
        self.menuBar = item_fac.get_widget('<main>')

        # -- HBox for Entry, Button --
        self.searchbar = gtk.HBox()
        # -- TextEntry --
        self.entry = gtk.Entry()
	self.entry.connect("key_press_event",self.on_entry_press)
        # -- Search Button --
        self.sbutton = gtk.Button(_("Search"))
        self.sbutton.connect("clicked", self.on_sbutton_clicked)
	# -- Chinese <-> English --
	self.etocradio = gtk.RadioButton(None, "Eng to Chn")
	self.ctoeradio = gtk.RadioButton(self.etocradio, "Chn to Eng")
	# -- Check Button --
	self.smartsearch = 0
	self.cbutton = gtk.CheckButton(_("Smart Search"))
	self.cbutton.connect("toggled", self.on_cbutton_clicked)
        #--
        self.searchbar.pack_start(self.entry, True)
        self.searchbar.pack_start(self.sbutton, False)
        self.searchbar.pack_start(self.cbutton, False)
	self.searchbar.pack_start(self.etocradio, False)
	self.searchbar.pack_start(self.ctoeradio, False)

        # -- HBox for Word and Dictionary
	self.dictbox = gtk.HBox()
        # -- CList for Word Selection
        self.wordlist = gtk.CList(1)
	self.wordlist.set_size_request(120,200)
        self.wordlist.set_column_width(0,100)
	self.wordlist.connect('select_row',self.on_select_row_wordlist)
        self.wordlistSW = gtk.ScrolledWindow()
        self.wordlistSW.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.wordlistSW.set_shadow_type(gtk.SHADOW_IN)
        self.wordlistSW.add(self.wordlist)

        # -- TextView for Dictionary View
        self.dicttext = gtk.TextView()
	self.dicttext.set_size_request(300,200)
	self.dicttext.set_editable(0)
        self.dicttextSW = gtk.ScrolledWindow()
        self.dicttextSW.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.dicttextSW.set_shadow_type(gtk.SHADOW_IN)
        self.dicttextSW.add(self.dicttext)
	# --
	self.dictbox.pack_start(self.wordlistSW, True)
	self.dictbox.pack_start(self.dicttextSW, True)

        #-------------------Packing--------------------#
        self.toplevelVBox.pack_start(self.menuBar, False)
        self.toplevelVBox.pack_start(self.searchbar, False)
        self.toplevelVBox.pack_start(self.dictbox, True)

	self.mainWindow.add(self.toplevelVBox)
        #self.mainWindow.set_size_request(600, 500)

	self.backend = dictBackend.dictBackend()

        self.mainWindow.show_all()
        gtk.main()

	
    def on_select_row_wordlist(self, *args):
        text = gtk.TextBuffer(None)
	word = self.wordlist.get_text(args[1], args[2])
	text = self.backend.search_word(word, False, 0)
	self.dicttext.set_buffer(text)
	
    def on_entry_press(self, *args):
        if args[1].keyval in (gtk.keysyms.KP_Enter, gtk.keysyms.Return):
	    self.sbutton.clicked()    

    def on_sbutton_clicked(self, *args):
        search_all = False

	text = gtk.TextBuffer(None)
	#Check if it is Chn to Eng
	if self.ctoeradio.get_active():
	    search_all = 1
        text = self.backend.search_word(self.entry.get_text(), True, search_all)
	self.dicttext.set_buffer(text)

        #update Word List
        self.wordlist.clear()
	for x in range(len(self.backend.entries)):
	    word = self.backend.process_line(self.backend.entries[x])['word']
	    self.wordlist.append((word,))

    def on_cbutton_clicked(self, *args):
        self.backend.smartsearch = self.cbutton.get_active()

